/*    
       This software may be used and distributed according to the terms of
       the GNU General Public License (GPL), incorporated herein by
       reference.  Drivers based on this skeleton fall under the GPL and
       must retain the authorship (implicit copyright) notice.
 
       This program is distributed in the hope that it will be useful, but
       WITHOUT ANY WARRANTY; without even the implied warranty of
       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
       General Public License for more details.
 */
package cricketdaemon.reader.parse;

import cricketdaemon.Util;
/**
 * A FieldParser that parses the input bytes as an ASCII String.
 *
 * @author Allen Miu
 */
public class FieldParser_ASCII implements FieldParser
{
    public static FieldParser instance = new FieldParser_ASCII();

    private FieldParser_ASCII()
    {
    }

    public Object parse(byte[] beacon, int offset, int length)
    {
	String result = null;
	try {
	    result = new String(beacon, offset, length, "US-ASCII");
	}
	catch (java.io.UnsupportedEncodingException e) {
	    Util.warn(e.getMessage());
	} 
	//System.out.println("FieldParser_ASCII::parse() "+result);
	return result;
    }

    public Object stringToReturnType(String s) 
    {
	return s;
    }

    public Object GPSDStringToReturnType(String s)
    {
	return stringToReturnType(s);
    }

    public byte[] unparse(Object o)
    {
	return ((String) o).getBytes();
    }
}
